Imports Microsoft.Office.Interop
Imports System.Runtime.InteropServices

Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        On Error GoTo ErrorHandler
        Dim oAccess As Access.Application
        Dim oForm As Access.Form
        Dim oCtls As Access.Controls
        Dim oCtl As Access.Control
        Dim dbPath As String           ' Datenbankpfad zu Test.mdb
        ' Eine neue Access-Instanz fr die Automation starten:
        oAccess = New Access.ApplicationClass()
        ' Dafr sorgen, dass Access sichtbar ist:
        If Not oAccess.Visible Then oAccess.Visible = True
        ' Datenbankpfad ermitteln (die Datenbank befindet sich hier der Einfachheit wegen im Anwendungsverzeichnis!):
        dbPath = Application.StartupPath & "\Test.mdb"
        'Datenbank ffnen (im Shared Mode):
        oAccess.OpenCurrentDatabase(filepath:=dbPath, Exclusive:=False)
        'Eventuell geffnete Formulare schlieen:
        For Each oForm In oAccess.Forms
            oAccess.DoCmd.Close(ObjectType:=Access.AcObjectType.acForm, _
                ObjectName:=oForm.Name, Save:=Access.AcCloseSave.acSaveNo)
        Next
        If oForm IsNot Nothing Then Marshal.ReleaseComObject(oForm)
        oForm = Nothing
        'Das Formular im Datenbankfenster auswhlen und den Fokus erteilen:
        oAccess.DoCmd.SelectObject(ObjectType:=Access.AcObjectType.acForm, ObjectName:="Bericht aufrufen", InDatabaseWindow:=True)
        'Das Formular anzeigen und seine Beschriftung editieren:
        oAccess.DoCmd.OpenForm(FormName:="Bericht aufrufen", View:=Access.AcFormView.acNormal)
        oForm = oAccess.Forms("Bericht aufrufen")
        oForm.Caption = "Access-Automation mit Visual Basic 2010"
        'Die Controls-Auflistung benutzen, um die Beschriftung der Schaltflche Befehl1 zu editieren:
        oCtls = oForm.Controls
        oCtl = oCtls.Item("Befehl1")
        oCtl.Caption = "Report aufrufen"
        Marshal.ReleaseComObject(oCtl)
        oCtl = Nothing
        oForm.SetFocus()
        '       Objekte(freigeben)
        Marshal.ReleaseComObject(oCtls)
        oCtls = Nothing
        Marshal.ReleaseComObject(oForm)
        oForm = Nothing
        'Application-Objekt freigeben und erlauben, dass Access durch den Anwender geschlossen wird:
        If Not oAccess.UserControl Then oAccess.UserControl = True
        Marshal.ReleaseComObject(oAccess)
        oAccess = Nothing
        Exit Sub
        'Diverse Fehlerbehandlungen (bei einem unerwarteten Fehlern wird versucht, Access zu schlieen):
ErrorCleanup:
        On Error Resume Next
        Marshal.ReleaseComObject(oCtl)
        oCtl = Nothing
        Marshal.ReleaseComObject(oCtls)
        oCtls = Nothing
        Marshal.ReleaseComObject(oForm)
        oForm = Nothing
        oAccess.Quit(Option:=Access.AcQuitOption.acQuitSaveNone)
        Marshal.ReleaseComObject(oAccess)
        oAccess = Nothing
        Exit Sub

ErrorHandler:
        MsgBox(Err.Number & ": " & Err.Description, MsgBoxStyle.MsgBoxSetForeground, "Error Handler")
        Resume ErrorCleanup
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.Close()
    End Sub
End Class
