/******************************************************************************************
Sortieren mit C (32-Bit-Version) & Testen diverser Aufrufparameter 
Copyright (c) 2007 by Th.Gewinnus
******************************************************************************************/

#include <windows.h>

/*****************************************************************************************
Testen von Funktionen, Datentypen, ByVal etc.
******************************************************************************************/

BYTE _stdcall TestByte (BYTE byt, LPBYTE pbyt)
{
	*pbyt = byt;
	return byt + 1;
}

short _stdcall TestInteger (short intgr, short far *pintgr)
{
	*pintgr = intgr;
	return intgr + 1;
}

short _stdcall TestBoolean (short bln, short far *pbln)
{
	*pbln = ~bln;
	return bln;
}

LONG _stdcall TestLong (LONG lng, LPLONG plng)
{
	*plng = lng;
	return lng + 1;
}

float _stdcall TestSingle (float sng, float far *psng)
{
	*psng = sng;
	return sng + (float)1.99;
}

double _stdcall TestDouble (double dbl, double far *pdbl)
{
	*pdbl = dbl;
	return dbl + 1.99;
}


                    
/*****************************************************************************************
Sortieralgorithmus  : Shellsort
Parameter           : Array, Anzahl Feldelemente 
******************************************************************************************/
void _stdcall Sortiere(double a[],long n)

{
long k,i,j;
double h;

  k=n/2;
  while (k>0)
  { for (i=0; i<n-k; i++)
    { j=i;
      while (j>=0 && a[j]>a[j+k])
      { h=a[j]; a[j]=a[j+k]; a[j+k]=h; j=j-k; }
    }
    k=k/2;
  }
}

void _stdcall Test(BSTR s,BSTR *ps)
{
	MessageBoxA( GetFocus(),(LPCSTR)s,"Info", MB_OK | MB_SYSTEMMODAL);
    SysReAllocString (ps, (BSTR)"Hallo User");
	return;
}


BOOL WINAPI DllMain (HINSTANCE hDLL, DWORD dwReason, LPVOID lpReserved)
{
  switch (dwReason) {
   case DLL_PROCESS_ATTACH:
		MessageBoxA( GetFocus(),"Attache","Info", MB_OK | MB_SYSTEMMODAL);
        break;
   case DLL_PROCESS_DETACH:
    	MessageBoxA( GetFocus(),"Detache","Info", MB_OK | MB_SYSTEMMODAL);
        break;
  }
return TRUE;
}

